import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
/**
 * 单元格属性
 */
var contentSchema = {
  type: 'object',
  properties: {
    text: {
      type: 'string',
      title: '文本'
    },
    icon: {
      type: 'string',
      title: '图标',
      default: ''
    }
  }
};
export var contentModel = {
  key: 'content',
  schema: function schema() {
    return contentSchema;
  },
  emitter: function emitter(config) {
    return {
      icon: config.content.text,
      children: config.content.text
    };
  }
};
export var dynamicContentModel = _objectSpread(_objectSpread({}, contentModel), {}, {
  schema: function schema(mode) {
    return {
      type: 'object',
      properties: {
        text: {
          type: 'string',
          title: '文本',
          default: mode === 'prod' ? 'prod' : 'dev'
        },
        icon: {
          type: 'string',
          title: '图标',
          default: ''
        }
      }
    };
  }
});