import type { FC, ReactNode } from 'react';
import type { Viewport } from 'reactflow';
import 'reactflow/dist/style.css';
export interface FreeCanvasProps {
    /** 自由画布组件的子元素 */
    children: ReactNode;
    /** 视口的初始值 */
    viewport?: Viewport;
    /** 视口的默认值 */
    defaultViewport?: Viewport;
    /** 是否显示控制面板 */
    control?: boolean;
    /**
     * 视口变化时的回调函数
     * @param viewport - 视口信息
     */
    onViewportChange?: (viewport: Viewport) => void;
    /**
     * 额外控制按钮
     */
    extraControlBtns?: React.ReactNode[];
}
declare const Canvas: FC<FreeCanvasProps>;
export default Canvas;
