/// <reference types="react" />
import { HIGHLIGHT_LANGUAGES } from './hooks/useShiki';
import { ThemeType } from './theme';
export interface HighlightProps {
    /**
     * @description 样式
     * @ignore
     */
    style?: React.CSSProperties;
    /**
     * @description className 类名
     * @ignore
     */
    className?: string;
    /**
     * @title 指定语言
     * @description 指定语言
     * @renderType select
     * @default "typescript"
     */
    language?: string;
    /**
     * @title 主题
     * @description 主题颜色, dark 黑色主题，light 白色主题
     * @default "light"
     */
    theme?: ThemeType;
    /**
     * @title 高亮内容
     * @description 高亮内容
     */
    children?: any;
    /**
     * @title 是否使用要使用行号
     * @description 是否需要展示代码块左侧的行号
     * @default false
     */
    lineNumber?: boolean;
    /**
     * @title 是否展示复制按钮
     * @description 是否需要展示复制按钮
     * @default true
     */
    copyable?: boolean;
    /**
     * @title 复制按钮点击后回调
     */
    onCopy?: (children: any) => void;
    /**
     * 高亮类型
     */
    type?: 'pure' | 'block';
    /**
     * 是否需默认展示语言种类
     */
    showLanguage?: boolean;
}
declare const Highlight: (props: HighlightProps) => import("react/jsx-runtime").JSX.Element;
export { HIGHLIGHT_LANGUAGES, Highlight };
