import { createStoreUpdater } from 'zustand-utils';
import { useStoreApi } from "../store";
var StoreUpdater = function StoreUpdater(_ref) {
  var icon = _ref.icon,
    defaultIcon = _ref.defaultIcon,
    iconfontScripts = _ref.iconfontScripts,
    defaultIconfontScripts = _ref.defaultIconfontScripts,
    onIconChange = _ref.onIconChange,
    onIconfontScriptsChange = _ref.onIconfontScriptsChange,
    activeIconfontScript = _ref.activeIconfontScript,
    defaultActiveIconfontScript = _ref.defaultActiveIconfontScript,
    onActiveIconfontScriptChange = _ref.onActiveIconfontScriptChange;
  var storeApi = useStoreApi();
  var useStoreUpdater = createStoreUpdater(storeApi);
  useStoreUpdater('icon', defaultIcon, []);
  useStoreUpdater('icon', icon);
  useStoreUpdater('onIconChange', onIconChange);
  useStoreUpdater('iconfontScripts', iconfontScripts, [iconfontScripts], function () {
    storeApi.setState({
      iconfontScripts: iconfontScripts,
      outsourceIconfontScripts: iconfontScripts
    });
  });
  useStoreUpdater('iconfontScripts', defaultIconfontScripts, []);
  useStoreUpdater('onIconfontScriptsChange', onIconfontScriptsChange);
  useStoreUpdater('activeIconfontScript', activeIconfontScript, [activeIconfontScript], function (_ref2) {
    var activeIconfontScript = _ref2.activeIconfontScript;
    storeApi.getState().selectScript(activeIconfontScript);
  });
  useStoreUpdater('activeIconfontScript', defaultActiveIconfontScript, [], function (_ref3) {
    var activeIconfontScript = _ref3.activeIconfontScript;
    storeApi.getState().selectScript(activeIconfontScript);
  });
  useStoreUpdater('onActiveIconfontScriptChange', onActiveIconfontScriptChange);
  return null;
};
export default StoreUpdater;