import { PlusOutlined, UpOutlined } from '@ant-design/icons';
import { Button, Result, Tag } from 'antd';
import { memo } from 'react';
import { Flexbox } from 'react-layout-kit';
import ActionIcon from "../../ActionIcon";
import { iconfontScriptsChangeable, isEmptyIconfontScripts, useStore } from "../store";
import { useStyles } from "./IconfontScript.style";
import ScriptEditor from "../components/ScriptEditor";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var IconfontScripts = /*#__PURE__*/memo(function () {
  var _useStyles = useStyles(),
    styles = _useStyles.styles,
    cx = _useStyles.cx;
  var _useStore = useStore(),
    iconfontScripts = _useStore.iconfontScripts,
    showForm = _useStore.showForm,
    activeIconfontScript = _useStore.activeIconfontScript,
    removeScripts = _useStore.removeScripts,
    selectScript = _useStore.selectScript,
    toggleForm = _useStore.toggleForm;
  var isEmptyScripts = useStore(isEmptyIconfontScripts);
  var canChangeIconfontScripts = useStore(iconfontScriptsChangeable);
  return isEmptyScripts ? showForm ? /*#__PURE__*/_jsx(ScriptEditor, {}) : /*#__PURE__*/_jsx(Result, {
    status: 'info',
    style: {
      padding: 0,
      paddingTop: 8
    },
    subTitle: '暂未添加图标库，请先添加 Iconfont 图标库',
    extra: /*#__PURE__*/_jsx(Flexbox, {
      children: /*#__PURE__*/_jsx(Button, {
        size: 'small',
        onClick: function onClick() {
          return toggleForm(true);
        },
        type: 'primary',
        children: "\u7ACB\u5373\u6DFB\u52A0"
      })
    })
  }) : /*#__PURE__*/_jsxs(Flexbox, {
    gap: 8,
    children: [/*#__PURE__*/_jsxs(Flexbox, {
      gap: 4,
      horizontal: true,
      children: [
      // 如果隐藏按钮
      !canChangeIconfontScripts ? null : showForm ? /*#__PURE__*/_jsx(ActionIcon, {
        size: 20,
        onClick: function onClick() {
          return toggleForm(false);
        },
        icon: /*#__PURE__*/_jsx(UpOutlined, {})
      }) : /*#__PURE__*/_jsxs(Tag, {
        className: styles.add,
        onClick: function onClick() {
          toggleForm(true);
        },
        children: [/*#__PURE__*/_jsx(PlusOutlined, {}), " \u6DFB\u52A0"]
      }), /*#__PURE__*/_jsx(Flexbox, {
        horizontal: true,
        children: iconfontScripts.map(function (s) {
          var checked = s.url === activeIconfontScript;
          return /*#__PURE__*/_jsx(Tag, {
            closable: canChangeIconfontScripts,
            onClose: function onClose() {
              removeScripts(s.url);
            },
            onClick: function onClick() {
              selectScript(checked ? '' : s.url);
            },
            className: cx(styles.tag, checked ? styles.checked : ''),
            children: s.name
          }, s.url);
        })
      })]
    }), showForm && /*#__PURE__*/_jsx(ScriptEditor, {})]
  });
});
export default IconfontScripts;