export var isEmptyIconfontScripts = function isEmptyIconfontScripts(s) {
  return !s.iconfontScripts || s.iconfontScripts.length === 0;
};
export var selectedListSelector = function selectedListSelector(s) {
  return s.panelTabKey === 'iconfont' ? s.iconfontIconList : s.antdIconList;
};
export var isEmptyIconList = function isEmptyIconList(s) {
  var list = selectedListSelector(s);
  return !list || list.length === 0;
};
export var displayListSelector = function displayListSelector(s) {
  var list = selectedListSelector(s);
  var filterKeywords = s.filterKeywords;
  return list.filter(function (i) {
    if (!filterKeywords) return true;
    switch (i.type) {
      case 'antd':
      case 'custom':
        return i.componentName.toLowerCase().includes(filterKeywords.toLowerCase());
      case 'iconfont':
        return i.props.type.toLowerCase().includes(filterKeywords.toLowerCase());
    }
  });
};

// 如果外部传入 iconfontScripts
// 并且不设置 onChange 方法
// 那么就不能修改图标源
export var iconfontScriptsChangeable = function iconfontScriptsChangeable(s) {
  return !s.outsourceIconfontScripts || !!s.onIconfontScriptsChange;
};