import type { StateCreator } from 'zustand/vanilla';
import type { ExternalScripts, IconUnit } from '../types';
import type { State } from './initialState';
export interface Action {
    resetIcon: () => void;
    togglePanel: () => void;
    selectIcon: (icon: IconUnit) => void;
    removeScripts: (url: string) => void;
    selectScript: (url: string) => void;
    toggleForm: (visible?: boolean) => void;
    addScript: (script: ExternalScripts) => void;
    updateScripts: (scripts: ExternalScripts[]) => void;
}
export type Store = State & Action;
declare const vanillaStore: StateCreator<Store, [['zustand/devtools', never]]>;
export default vanillaStore;
