import { useEffect, useRef } from 'react';
import { InteractModel } from "./InteractModel";
export var useInteractModel = function useInteractModel(rules) {
  var container = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : document;
  var interactModel = useRef(new InteractModel(rules, container));

  // 任何时候进行刷新，都要重新
  useEffect(function () {
    interactModel.current.initModels();
  });
  useEffect(function () {
    interactModel.current = new InteractModel(rules, container);
  }, [rules, container]);
  return interactModel.current;
};