/**
 * 获取容器元素
 * @param getContainer
 */
export var getContainerElement = function getContainerElement(getContainer) {
  if (getContainer) {
    if (typeof getContainer === 'string') {
      var element = document.querySelector(getContainer);
      if (element) return element;
    }
    if (getContainer instanceof HTMLElement) return getContainer;
    if (typeof getContainer === 'function') return getContainer();
  }
  return document;
};

/**
 * 生成事件监听器
 * @param ele
 * @param type
 * @param method
 */
export var initListener = function initListener(ele, type, method) {
  if (ele instanceof Array) {
    return {
      register: function register() {
        ele.forEach(function (e) {
          e.addEventListener(type, method);
        });
      },
      unRegister: function unRegister() {
        ele.forEach(function (e) {
          e.removeEventListener(type, method);
        });
      }
    };
  } else {
    return {
      register: function register() {
        return ele.addEventListener(type, method);
      },
      unRegister: function unRegister() {
        return ele.removeEventListener(type, method);
      }
    };
  }
};
export var createTestElement = function createTestElement(slelector) {
  var attr = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'data-uxid';
  var div = document.createElement('div');
  div.setAttribute(attr, slelector);
  document.body.appendChild(div);
  return div;
};