/// <reference types="react" />
import { FlexboxProps } from 'react-layout-kit';
import { HeaderFooterSettings } from './components/HeaderAndFooter';
import { PannelSettings } from './components/PannelDefault';
export type LayoutTypeEnum = 'Left&Right' | 'LeftFull' | 'RightFull' | 'Bottom' | string | null | undefined;
export type ThemeLayoutType = 'pure' | 'ghost' | 'block' | string;
interface LayoutProps extends FlexboxProps {
    header?: HeaderFooterSettings | false;
    footer?: HeaderFooterSettings | false;
    leftPannel?: PannelSettings | false;
    rightPannel?: PannelSettings | false;
    bottomPannel?: PannelSettings | false;
    centerPannel?: PannelSettings | false;
    type?: LayoutTypeEnum;
    themeType?: ThemeLayoutType;
}
declare const WrapperLayout: React.FC<LayoutProps>;
export { WrapperLayout as Layout };
