import { DevtoolsOptions } from 'zustand/middleware';
import { AwarenessSlice, AwarenessSliceState } from './slices/awareness';
import { CanvasSlice, PublicCanvasState } from './slices/canvas';
import { ConfigPublicState, ConfigSlice } from './slices/config';
import { ConfigPanelSlice } from './slices/configPanel';
import { GeneralSlice, GeneralSliceState } from './slices/general';
/**
 * ProBuilderState 接口描述编辑器状态
 * @template Config - 编辑器配置属性类型
 * @template PresenceAsset - 编辑器供外部感知的视图状态类型
 */
export type ProBuilderState<Config = any, PresenceAsset = any> = GeneralSliceState & ConfigPublicState<Config> & PublicCanvasState & AwarenessSliceState<PresenceAsset>;
export type InternalProBuilderStore = ProBuilderState & ConfigSlice & CanvasSlice & ConfigPanelSlice & AwarenessSlice & GeneralSlice;
export declare const createStore: (options?: boolean | DevtoolsOptions) => import("zustand/traditional").UseBoundStoreWithEqualityFn<Omit<import("zustand").StoreApi<InternalProBuilderStore>, "setState"> & {
    setState<A extends string | {
        type: string;
    }>(partial: InternalProBuilderStore | Partial<InternalProBuilderStore> | ((state: InternalProBuilderStore) => InternalProBuilderStore | Partial<InternalProBuilderStore>), replace?: boolean, action?: A): void;
}>;
