import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import isEqual from 'fast-deep-equal';
import { optionalDevtools } from 'zustand-utils';
import { createWithEqualityFn } from 'zustand/traditional';
import { awarenessSlice } from "./slices/awareness";
import { canvasSlice } from "./slices/canvas";
import { configSlice } from "./slices/config";
import { configPanelSlice } from "./slices/configPanel";
import { generalSlice } from "./slices/general";

/**
 * ProBuilderState 接口描述编辑器状态
 * @template Config - 编辑器配置属性类型
 * @template PresenceAsset - 编辑器供外部感知的视图状态类型
 */

var vanillaStore = function vanillaStore() {
  return _objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread({}, generalSlice.apply(void 0, arguments)), configSlice.apply(void 0, arguments)), canvasSlice.apply(void 0, arguments)), configPanelSlice.apply(void 0, arguments)), awarenessSlice.apply(void 0, arguments));
};
export var createStore = function createStore() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  var devtools = optionalDevtools(options !== false);
  var devtoolOptions = options === false ? undefined : options === true ? {
    name: 'ProBuilderStore'
  } : options;
  return createWithEqualityFn()(devtools(vanillaStore, devtoolOptions), isEqual);
};