import { StackItem } from 'yjs/dist/src/utils/UndoManager';
import { StateCreator } from 'zustand';
import { InternalProBuilderStore } from '../createStore';
export declare enum TabKey {
    canvas = 0,
    code = 1
}
export declare enum EditorMode {
    Design = "design",
    Develop = "develop"
}
export interface GeneralSliceState {
    /** 用户角色 */
    mode: EditorMode;
}
/**
 * 通用公共动作
 */
export interface GeneralPublicAction {
    /**
     * 撤销操作
     */
    undo: () => void;
    /**
     * 重做操作
     */
    redo: () => void;
    /**
     * 撤销栈
     */
    undoStack: () => StackItem[];
    /**
     * 重做栈
     */
    redoStack: () => StackItem[];
}
export interface GeneralSlice extends GeneralPublicAction, GeneralSliceState {
}
export declare const generalSlice: StateCreator<InternalProBuilderStore, [
    ['zustand/devtools', never]
], [
], GeneralSlice>;
