import { ConfigPublicAction } from '../store/slices/config';
import { GeneralPublicAction } from '../store/slices/general';
/**
 * ProBuilder 实例对象
 * @template Config - 配置信息的类型
 * @template Props - 组件属性的类型
 */
export interface ProEditorInstance<Config = any, Props = any> extends ConfigPublicAction, GeneralPublicAction {
    /**
     * 获取配置信息
     * @returns {Config} - 配置信息
     */
    getConfig: () => Config | null;
    /**
     * 获取组件属性
     * @returns {Props} - 组件属性
     */
    getProps: () => Props;
}
export declare const useProEditor: <T>() => ProEditorInstance<T, any>;
