import { StateCreator, StoreMutatorIdentifier } from 'zustand/vanilla';
/**
 * 提供给用户的配置项
 */
export interface ProEditorOptions<S, EditorSaveState = S> {
    /** Name of the storage (must be unique) */
    name: string;
    /**
     * Filter the persisted value.
     *
     * @params state The state's value
     */
    partialize?: (state: S) => EditorSaveState;
}
export type ProEditorMiddleware = <T, Mps extends [StoreMutatorIdentifier, unknown][] = [], Mcs extends [StoreMutatorIdentifier, unknown][] = [], U = T>(initializer: StateCreator<T, [...Mps, ['pro-editor', unknown]], Mcs>, options: ProEditorOptions<T, U>) => StateCreator<T, Mps, [['pro-editor', U], ...Mcs]>;
export declare const proEditorMiddleware: ProEditorMiddleware;
