import { DevtoolsOptions } from 'zustand/middleware';
import { ConfigPublicState, ConfigSlice } from './slices/config';
import { GeneralSlice } from './slices/general';
/**
 * ProEditorState 接口描述编辑器状态
 * @template Config - 编辑器配置属性类型
 */
export type ProEditorState<Config = any> = ConfigPublicState<Config>;
export type InternalProEditorStore = ProEditorState & ConfigSlice & GeneralSlice;
export declare const createStore: (options?: boolean | DevtoolsOptions) => import("zustand/traditional").UseBoundStoreWithEqualityFn<Omit<import("zustand").StoreApi<InternalProEditorStore>, "setState"> & {
    setState<A extends string | {
        type: string;
    }>(partial: InternalProEditorStore | Partial<InternalProEditorStore> | ((state: InternalProEditorStore) => InternalProEditorStore | Partial<InternalProEditorStore>), replace?: boolean, action?: A): void;
}>;
