import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import isEqual from 'fast-deep-equal';
import { optionalDevtools } from 'zustand-utils';
import { createWithEqualityFn } from 'zustand/traditional';
import { configSlice } from "./slices/config";
import { generalSlice } from "./slices/general";

/**
 * ProEditorState 接口描述编辑器状态
 * @template Config - 编辑器配置属性类型
 */

var vanillaStore = function vanillaStore() {
  return _objectSpread(_objectSpread({}, generalSlice.apply(void 0, arguments)), configSlice.apply(void 0, arguments));
};
export var createStore = function createStore() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  var devtools = optionalDevtools(options !== false);
  var devtoolOptions = options === false ? undefined : options === true ? {
    name: 'ProEditorStore'
  } : options;
  return createWithEqualityFn()(devtools(vanillaStore, devtoolOptions), isEqual);
};