import { StateCreator } from 'zustand';
import { InternalProEditorStore } from '../createStore';
export interface StackItem {
    timestamp: number;
    name?: string;
    type?: string;
}
/**
 * 通用公共动作
 */
export interface GeneralPublicAction {
    /**
     * 撤销操作
     */
    undo: () => void;
    /**
     * 重做操作
     */
    redo: () => void;
    /**
     * 撤销栈
     */
    undoStack: () => StackItem[];
    /**
     * 重做栈
     */
    redoStack: () => StackItem[];
    undoLength: () => number;
    redoLength: () => number;
}
export type GeneralSlice = GeneralPublicAction;
export declare const generalSlice: StateCreator<InternalProEditorStore, [
    ['zustand/devtools', never]
], [
], GeneralSlice>;
