import { Doc, UndoManager } from 'yjs';
import { DocOpts } from 'yjs/dist/src/utils/Doc';
import { StackItem } from 'yjs/dist/src/utils/UndoManager';
export interface UserActionParams {
    type?: string | unknown;
    name?: string;
    timestamp?: number;
}
export declare class DocWithHistoryManager<T = object> extends Doc {
    private _internalHistoryKey;
    constructor(params?: DocOpts);
    undoManager: UndoManager;
    updateHistoryData: (value: Partial<T>) => void;
    recordHistoryData: (value: Partial<T>, userAction: UserActionParams) => void;
    getHistoryMap: () => import("yjs").Map<unknown>;
    getHistoryJSON: () => T;
    redo: () => StackItem;
    undo: () => StackItem;
}
