import { DivProps } from 'react-layout-kit';
export interface SnippetProps extends DivProps {
    /**
     * @description 内容区域
     */
    children: string;
    /**
     * @description 是否支持可复制的能力
     * @default true
     */
    copyable?: boolean;
    /**
     * @description 指定渲染的语言类型
     * @default 'tsx'
     */
    language?: string;
    /**
     * @description 是否添加聚光灯背景
     * @default false
     */
    spotlight?: boolean;
    /**
     * @description 开头渲染的符号标志
     */
    symbol?: string;
    /**
     * @description 组件的渲染类型
     * @default 'ghost'
     */
    type?: 'ghost' | 'block';
}
declare const Snippet: (props: SnippetProps) => import("react/jsx-runtime").JSX.Element;
export { Snippet };
