import _taggedTemplateLiteral from "@babel/runtime/helpers/esm/taggedTemplateLiteral";
var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7, _templateObject8, _templateObject9, _templateObject10;
import { createStyles, keyframes } from "../../../theme";
var boxShadowBorder = '0 0 0 calc(1px / var(--scale-x, 1)) rgba(0, 0, 0, 0.05)';
var boxShadowCommon = '0 1px calc(3px / var(--scale-x, 1)) 0 rgba(0, 0, 0, 0.15)';
var boxShadow = "".concat(boxShadowBorder, " ").concat(boxShadowCommon);
var pop = keyframes(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n\t0% {\n\t\tbox-shadow: var(--box-shadow);\n\t\ttransform: scale(1);\n\t}\n\t100% {\n\t\tbox-shadow: var(--box-shadow-picked-up);\n\t\ttransform: scale(var(--scale));\n\t}\n"])));
var fadeIn = keyframes(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n\t0% {\n\t  opacity: 0;\n\t}\n\t100% {\n\t  opacity: 1;\n\t}\n"])));
export var useStyle = createStyles(function (_ref) {
  var css = _ref.css,
    cx = _ref.cx,
    token = _ref.token,
    prefixCls = _ref.prefixCls;
  var prefix = "".concat(prefixCls, "-").concat(token.editorPrefix, "-sortable-list");
  return {
    // 透出给外层做前缀拼接
    tokenPrefixCls: prefix,
    item: cx("".concat(prefixCls, "-item"), css(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n        position: relative;\n        display: flex;\n        flex-grow: 1;\n        align-items: center;\n        justify-content: space-between;\n        box-sizing: border-box;\n        padding: 1px 0;\n        color: ", ";\n        font-size: 12px;\n        white-space: nowrap;\n        list-style: none;\n        border-radius: 4px;\n        outline: none;\n        transform: scale(var(--scale, 1));\n        transform-origin: 50% 50%;\n        transition: box-shadow 200ms cubic-bezier(0.18, 0.67, 0.6, 1.22);\n        -webkit-tap-highlight-color: transparent;\n\n        &:focus-visible {\n          box-shadow: 0 0 4px 1px #4c9ffe, ", ";\n        }\n\n        &:not(.", "-item-withHandle) {\n          cursor: grab;\n          -webkit-user-select: none;\n          user-select: none;\n          touch-action: none;\n        }\n\n        &-dragging:not(.", "-item-dragOverlay) {\n          z-index: 0;\n          opacity: var(--dragging-opacity, 0.5);\n\n          &:focus {\n            box-shadow: ", ";\n          }\n        }\n      "])), token.colorTextSecondary, boxShadow, prefix, prefix, boxShadow)),
    disabled: cx("".concat(prefixCls, "-item-disabled"), css(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n        color: #999;\n        background-color: #f1f1f1;\n        cursor: not-allowed;\n        &:focus {\n          box-shadow: 0 0 4px 1px rgba(0, 0, 0, 0.1), ", ";\n        }\n      "])), boxShadow)),
    dragOverlay: cx("".concat(prefixCls, "-item-dragOverlay"), css(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n        padding: 4px 0;\n        background-color: ", ";\n        border: none;\n        box-shadow: var(--box-shadow-picked-up);\n        transform: scale(var(--scale));\n        cursor: inherit;\n        opacity: 1;\n\n        /* box-shadow: 0 0px 6px 2px @focused-outline-color; */\n        animation: ", " 200ms cubic-bezier(0.18, 0.67, 0.6, 1.22);\n      "])), token.colorBgElevated, pop)),
    wrapper: cx("".concat(prefixCls, "-item-wrapper"), css(_templateObject6 || (_templateObject6 = _taggedTemplateLiteral(["\n        display: flex;\n        box-sizing: border-box;\n        transform: translate3d(var(--translate-x, 0), var(--translate-y, 0), 0)\n          scaleX(var(--scale-x, 1)) scaleY(var(--scale-y, 1));\n        transform-origin: 0 0;\n        touch-action: manipulation;\n\n        &:not(:last-child) {\n          margin-bottom: 2px;\n        }\n      "])))),
    wrapperFadeIn: cx("".concat(prefixCls, "-item-wrapper-fadeIn"), css(_templateObject7 || (_templateObject7 = _taggedTemplateLiteral(["\n        animation: ", " 500ms ease;\n      "])), fadeIn)),
    wrapperdragOverlay: cx("".concat(prefixCls, "-item-wrapper-dragOverlay"), css(_templateObject8 || (_templateObject8 = _taggedTemplateLiteral(["\n        --scale: 1.05;\n        --box-shadow: ", ";\n        --box-shadow-picked-up: ", ", -1px 0 15px 0 rgba(82, 82, 82, 0.01),\n          0 15px 15px 0 rgba(82, 82, 82, 0.25);\n\n        z-index: 999;\n      "])), boxShadow, boxShadowBorder)),
    actions: cx("".concat(prefixCls, "-item-actions"), css(_templateObject9 || (_templateObject9 = _taggedTemplateLiteral(["\n        z-index: 10;\n        color: hsla(0, 0, 0, 0.45);\n        opacity: 0;\n      "])))),
    content: cx("".concat(prefixCls, "-item-content"), css(_templateObject10 || (_templateObject10 = _taggedTemplateLiteral(["\n        position: relative;\n        width: 100%;\n        height: 24px;\n        border-radius: 2px;\n        min-width: 48px;\n\n        &:hover .", "-item-actions {\n          opacity: 1;\n        }\n      "])), prefixCls))
  };
});