import type { DragEndEvent, DragStartEvent } from '@dnd-kit/core';
import type { StateCreator } from 'zustand/vanilla';
import type { SortableListState } from '../type';
import { SortableListDispatchPayload } from '../type';
interface Action {
    handleDragStart: (event: DragStartEvent) => void;
    handleDragEnd: (event: DragEndEvent) => void;
    handleDragCancel: () => void;
    dispatchListData: (payload: SortableListDispatchPayload) => void;
}
export type Store = SortableListState & Action;
declare const vanillaStore: StateCreator<Store, [['zustand/devtools', never]]>;
export default vanillaStore;
