import type { UniqueIdentifier } from '@dnd-kit/core';
export declare function createRange<T = number>(length: number, initializer?: (index: number) => any): T[];
/**
 * Moves an array item from one position in an array to another.
 *
 * Note: This is a pure function so a new array will be returned, instead
 * of altering the array argument.
 *
 * @param array         Array in which to move an item.         (required)
 * @param moveIndex     The index of the item to move.          (required)
 * @param toIndex       The index to move item at moveIndex to. (required)
 */
export declare function move<T>(array: T[], moveIndex: number, toIndex: number): T[];
export declare const useLatest: (props: any) => any[];
export declare const getIndexOfActiveItem: (list: any[], id?: UniqueIdentifier) => number;
export declare const getUUID: (index: any) => string;
