import type { UniqueIdentifier } from '@dnd-kit/core';
import type { CSSProperties, FC, HTMLAttributes } from 'react';
import { FlattenNode } from '../../types';
export interface TreeItemProps extends Omit<HTMLAttributes<HTMLLIElement>, 'id'> {
    /**
     * @title 子节点数量
     */
    childCount?: number;
    /**
     * @title 是否是 overlay 对象
     */
    clone?: boolean;
    /**
     * @title 是否已折叠
     */
    collapsed?: boolean;
    /**
     * @title 是否已选中
     */
    selected?: boolean;
    /**
     * @title 节点深度
     */
    depth: number;
    /**
     * @title 是否禁止选中
     */
    disableSelection?: boolean;
    /**
     * @title 缩进宽度
     */
    indentationWidth: number;
    /**
     * @title 唯一标识符
     */
    id: UniqueIdentifier;
    /**
     * @title 折叠事件回调函数
     */
    onCollapse?: () => void;
    /**
     * @title 移除事件回调函数
     */
    onRemove?: () => void;
    /**
     * @title 节点数据
     */
    node: FlattenNode;
    /**
     * @title 是否展示更多
     */
    showExtra?: boolean;
    /**
     * @title 是否隐藏移除按钮
     */
    hideRemove?: boolean;
    /**
     * 虚拟滚动添加样式
     */
    virtualStyle?: CSSProperties;
}
declare const TreeItem: FC<TreeItemProps>;
export default TreeItem;
