import isEqual from 'fast-deep-equal';
import { createContext, optionalDevtools } from 'zustand-utils';
import { createWithEqualityFn } from 'zustand/traditional';
import vanillaStore from "./store";
var createStore = function createStore(showDevTools) {
  return createWithEqualityFn(optionalDevtools(showDevTools)(vanillaStore, {
    name: 'SortableTree'
  }), isEqual);
};
var _createContext = createContext(),
  useStore = _createContext.useStore,
  useStoreApi = _createContext.useStoreApi,
  Provider = _createContext.Provider;

// ========= 导出 ========= //

export * from "./selectors";
export { Provider, createStore, useStore, useStoreApi };