import { DragEndEvent, DragMoveEvent, DragOverEvent, DragStartEvent } from '@dnd-kit/core';
import { StateCreator } from 'zustand/vanilla';
import { FlattenNode } from '../../types';
import { InternalSortableTreeStore } from '../store';
export interface DndAction {
    resetState: () => void;
    getActiveNode: () => FlattenNode | null;
    handleDragStart: (event: DragStartEvent) => void;
    handleDragMove: (event: DragMoveEvent) => void;
    handleDragOver: (event: DragOverEvent) => void;
    handleDragEnd: (event: DragEndEvent) => void;
    handleDragCancel: () => void;
}
export declare const dndSlice: StateCreator<InternalSortableTreeStore, [
    ['zustand/devtools', never]
], [
], DndAction>;
