import { StateCreator } from 'zustand/vanilla';
import { MouseEvent } from 'react';
import { UniqueIdentifier } from '../../types';
import { InternalSortableTreeStore } from '../store';
export interface SelectionPublicAction {
    toggleNode: (id: UniqueIdentifier) => void;
    selectedNode: (id: UniqueIdentifier) => void;
    deselectedAll: () => void;
}
export interface SelectionSliceAction extends SelectionPublicAction {
    updateSelectedIds: (selectedKeys: UniqueIdentifier[]) => void;
    multiSelectNode: (id: UniqueIdentifier) => void;
    rowSelectNode: (id: UniqueIdentifier) => void;
    withKeyboardSelectNode: (event: MouseEvent<any>, id: UniqueIdentifier) => void;
}
export declare const selectionSlice: StateCreator<InternalSortableTreeStore, [
    ['zustand/devtools', never]
], [
], SelectionSliceAction>;
