/// <reference types="react" />
import { InputRef, InputProps as Props } from 'antd';
export interface InputProps extends Omit<Props, 'onChange' | 'value' | 'onAbort'> {
    /**
     * 输入框变化回调函数
     * @param value - 输入框的值
     */
    onChange?: (value: string) => void;
    /**
     * 输入框值变化前回调函数
     * @param value - 输入框的值
     */
    onValueChanging?: (value: string) => void;
    /**
     * 输入框的值
     */
    value?: string;
    defaultValue?: string;
}
export declare const Input: import("react").ForwardRefExoticComponent<InputProps & import("react").RefAttributes<InputRef>>;
