import type { InputNumberProps as Props } from 'antd';
import type { FC } from 'react';
export interface InputNumberProps extends Omit<Props, 'value' | 'defaultValue'> {
    /**
     * 输入框值变化前回调函数
     * @param value - 输入框的值
     */
    onValueChanging?: (value: number) => void;
    /**
     * 输入框的值
     */
    value?: number;
    defaultValue?: number;
}
export declare const InputNumber: FC<InputNumberProps>;
