import type { SegmentedProps as SProps } from 'antd';
import type { ReactNode } from 'react';
export interface SegmentedProps<T = string> extends Omit<SProps, 'value' | 'options' | 'onChange' | 'defaultValue'> {
    defaultValue?: T;
    value?: T;
    /**
     * 变更后的回调
     */
    onChange?: (tabKey: T) => void;
    /**
     * 选项值
     */
    options: {
        label: ReactNode;
        value: T;
        icon?: React.ReactNode;
    }[];
}
export declare const Segmented: <T = string>(props: SegmentedProps<T>) => JSX.Element;
