/// <reference types="react" />
import { type TooltipProps } from 'antd';
import { DivProps } from 'react-layout-kit';
export interface CopyButtonProps extends DivProps {
    /**
     * @description Additional class name
     */
    className?: string;
    /**
     * @description The text content to be copied
     */
    content: string;
    /**
     * @description The placement of the tooltip
     * @enum ['top', 'left', 'right', 'bottom', 'topLeft', 'topRight', 'bottomLeft', 'bottomRight', 'leftTop', 'leftBottom', 'rightTop', 'rightBottom']
     * @default 'right'
     */
    placement?: TooltipProps['placement'];
}
declare const CopyButton: import("react").NamedExoticComponent<CopyButtonProps>;
export default CopyButton;
