import { JSONSchema } from "../types/schema";
/**
 * 从schema 获取预设值
 * @param schema
 */
export declare const getDefaultValueFromSchema: (schema: JSONSchema) => any;
/**
 * 获取去重后的 props
 * @param props
 * @param schema
 */
export declare const getDiffPropsWithSchema: (props: any, schema?: JSONSchema) => any;
/**
 * 根据组件名称、props 生成 props 和 schema生成symbolMaster名称
 */
export declare const getSymbolMasterNameFromProps: (pkg: string, component: string, props: any, schema?: JSONSchema) => string;
/**
 * 获取组件库导入代码
 */
export declare const generateImportCode: (pkg: string, components: string[]) => string;
/**
 * 将 prop 转换成字符串
 */
export declare const createPropString: (key: string, value: string | number | boolean | symbol | object | undefined | Function | any[]) => string;
/**
 * 生成 React JSX 代码
 * @param component
 * @param props
 * @param PropStringFn
 */
export declare const generateJSXCode: (component: string, props: Record<string, any>, PropStringFn?: (key: string, value: string | number | boolean | symbol | object | undefined | Function | any[]) => string) => string;
